
package de.ivu.elect.presentation.exchange.action;

import static org.apache.commons.lang3.StringUtils.equalsIgnoreCase;

import javax.annotation.Nonnull;
import javax.inject.Inject;

import de.ivu.elect.business.CurrentCustomer;
import de.ivu.elect.business.datei.boundary.DateiExportExtendedDAO;
import de.ivu.elect.business.datei.entity.DateiExport;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.wahl.entity.NlWahlart;
import de.ivu.elect.presentation.ergebnis.exchange.NlWasErgebnisArtefaktNachGebietAbschlussBulkExportDescription;
import de.ivu.elect.presentation.ergebnis.menu.NlWasErgebnisArtefaktNachGebietKorrekturBulkExportMenuItemEntry;
import de.ivu.elect.presentation.menu.AbstractActionEntry;
import de.ivu.elect.presentation.security.AbstractGebietSecurity;

public class KorrekturDokumentErzeugenAction extends AbstractActionEntry<DateiExport> {

  private static final long serialVersionUID = 1L;

  @Inject
  private transient CurrentCustomer currentCustomer;

  @Inject
  private transient DateiExportExtendedDAO dateiExportExtendedDAO;

  @Inject
  private transient NlWasErgebnisBulkExportViewAction nlWasErgebnisBulkExportViewAction;

  @Inject
  private transient NlWasErgebnisArtefaktNachGebietKorrekturBulkExportMenuItemEntry nlWasErgebnisArtefaktNachGebietKorrekturBulkExportMenuItemEntry;

  public KorrekturDokumentErzeugenAction() {
    super();
  }

  @Override
  protected boolean isDisabledInternal(@Nonnull DateiExport entity) {
    return nlWasErgebnisArtefaktNachGebietKorrekturBulkExportMenuItemEntry.isDisabled() || !isErwarteterTyp(entity) || !isGsb(entity) /*ELECT-15693*/;
  }

  private boolean isGsb(DateiExport entity) {
    if (entity == null) {
      return false;
    }

    return NlWahlart.isWasGSB(entity.getDatei().getWahl(), currentCustomer.getCustomer());
  }

  private boolean isErwarteterTyp(DateiExport entity) {
    return equalsIgnoreCase(entity.getDatei().getFormat(), NlWasErgebnisArtefaktNachGebietAbschlussBulkExportDescription.FILE_FORMAT_NAME);
  }

  @Override
  protected DateiExport attach(DateiExport entity) {
    return dateiExportExtendedDAO.attach(entity);
  }

  @Override
  public boolean hasPrincipalRequiredPermission() {
    return super.hasPrincipalRequiredPermission() && nlWasErgebnisArtefaktNachGebietKorrekturBulkExportMenuItemEntry.isPossible();
  }

  @Override
  protected UseCasePermission getRequiredPermission() {
    return UseCasePermission.GEBIET_ERGEBNISEINGABESTATUS_SETZEN_ABGESCHLOSSEN;
  }

  @Override
  protected AbstractGebietSecurity getGebietSecurity() {
    return KEINE_GEBIET_SECURITY;
  }

  @Override
  protected boolean isFireChangeEvent() {
    return false;
  }

  @Override
  protected String doIt(DateiExport dateiExport) {
    return nlWasErgebnisBulkExportViewAction.setzeDateiExport(dateiExport);
  }

  @Override
  protected void fireChangeEvent() {

  }

  @Override
  public String getLabelKey() {
    return "ergebnisdokument.nach.gebiet.korrektur.export.action.label"; // ELECT-15731
  }

  @Override
  public String getIcon() {
    return nlWasErgebnisArtefaktNachGebietKorrekturBulkExportMenuItemEntry.getIcon();
  }
}
